diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/utils/tests/test-ns3.py ns-3.41/utils/tests/test-ns3.py
--- ns-3.40/utils/tests/test-ns3.py	2023-09-27 13:30:37.934840000 -0700
+++ ns-3.41/utils/tests/test-ns3.py	2024-02-09 14:44:08.633795300 -0800
@@ -2137,7 +2335,9 @@
                                   list(APPEND CMAKE_PREFIX_PATH ./{lib}/cmake/ns3)
                                   find_package(ns3 {version} COMPONENTS libcore)
                                   target_link_libraries(test PRIVATE ns3::libcore)
-                                  """.format(lib=("lib64" if lib64 else "lib"), version=version)
+                                  """.format(
+                lib=("lib64" if lib64 else "lib"), version=version
+            )
             ns3_import_methods.append(cmake_find_package_import)
 
             # Import ns-3 as pkg-config libraries
@@ -2146,21 +2346,24 @@
                                include(FindPkgConfig)
                                pkg_check_modules(ns3 REQUIRED IMPORTED_TARGET ns3-core{version})
                                target_link_libraries(test PUBLIC PkgConfig::ns3)
-                               """.format(lib=("lib64" if lib64 else "lib"),
-                                          version="=" + version if version else ""
-                                          )
+                               """.format(
+                lib=("lib64" if lib64 else "lib"), version="=" + version if version else ""
+            )
             if shutil.which("pkg-config"):
                 ns3_import_methods.append(pkgconfig_import)
 
             # Test the multiple ways of importing ns-3 libraries
             for import_method in ns3_import_methods:
-                test_cmake_project = """
-                                     cmake_minimum_required(VERSION 3.10..3.10)
+                test_cmake_project = (
+                    """
+                                     cmake_minimum_required(VERSION 3.12..3.12)
                                      project(ns3_consumer CXX)
-                                     set(CMAKE_CXX_STANDARD 17)
+                                     set(CMAKE_CXX_STANDARD 20)
                                      set(CMAKE_CXX_STANDARD_REQUIRED ON)
                                      add_executable(test main.cpp)
-                                     """ + import_method
+                                     """
+                    + import_method
+                )
 
                 test_cmake_project_file = os.sep.join([install_prefix, "CMakeLists.txt"])
                 with open(test_cmake_project_file, "w", encoding="utf-8") as f:
@@ -2170,18 +2373,21 @@
                 cmake = shutil.which("cmake")
                 return_code, stdout, stderr = run_program(
                     cmake,
-                    "-DCMAKE_BUILD_TYPE=debug -G\"{generator}\" .".format(generator=platform_makefiles),
-                    cwd=install_prefix
+                    '-DCMAKE_BUILD_TYPE=debug -G"{generator}" .'.format(
+                        generator=platform_makefiles
+                    ),
+                    cwd=install_prefix,
                 )
 
                 if version == "3.00":
                     self.assertEqual(return_code, 1)
                     if import_method == cmake_find_package_import:
-                        self.assertIn('Could not find a configuration file for package "ns3" that is compatible',
-                                      stderr.replace("\n", ""))
+                        self.assertIn(
+                            'Could not find a configuration file for package "ns3" that is compatible',
+                            stderr.replace("\n", ""),
+                        )
                     elif import_method == pkgconfig_import:
-                        self.assertIn('A required package was not found',
-                                      stderr.replace("\n", ""))
+                        self.assertIn("A required package was not found", stderr.replace("\n", ""))
                     else:
                         raise Exception("Unknown import type")
                 else:
@@ -2202,11 +2408,17 @@
                     if win32:
                         test_program = os.path.join(install_prefix, "test.exe")
                         env_sep = ";" if ";" in os.environ["PATH"] else ":"
-                        env = {"PATH": env_sep.join([os.environ["PATH"], os.path.join(install_prefix, "lib")])}
+                        env = {
+                            "PATH": env_sep.join(
+                                [os.environ["PATH"], os.path.join(install_prefix, "lib")]
+                            )
+                        }
                     else:
                         test_program = "./test"
                         env = None
-                    return_code, stdout, stderr = run_program(test_program, "", cwd=install_prefix, env=env)
+                    return_code, stdout, stderr = run_program(
+                        test_program, "", cwd=install_prefix, env=env
+                    )
                     self.assertEqual(return_code, 0)
 
         # Uninstall
@@ -2224,14 +2436,15 @@
         @return None
         """
         # Build.
-        targets = {"scratch/scratch-simulator": "scratch-simulator",
-                   "scratch/scratch-simulator.cc": "scratch-simulator",
-                   "scratch-simulator": "scratch-simulator",
-                   "scratch/subdir/scratch-subdir": "subdir_scratch-subdir",
-                   "subdir/scratch-subdir": "subdir_scratch-subdir",
-                   "scratch-subdir": "subdir_scratch-subdir",
-                   }
-        for (target_to_run, target_cmake) in targets.items():
+        targets = {
+            "scratch/scratch-simulator": "scratch-simulator",
+            "scratch/scratch-simulator.cc": "scratch-simulator",
+            "scratch-simulator": "scratch-simulator",
+            "scratch/subdir/scratch-subdir": "subdir_scratch-subdir",
+            "subdir/scratch-subdir": "subdir_scratch-subdir",
+            "scratch-subdir": "subdir_scratch-subdir",
+        }
+        for target_to_run, target_cmake in targets.items():
             # Test if build is working.
             build_line = "target scratch_%s" % target_cmake
             return_code, stdout, stderr = run_ns3("build %s" % target_to_run)
@@ -2252,14 +2465,14 @@
         """
 
         # First enable examples
-        return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" --enable-examples")
+        return_code, stdout, stderr = run_ns3('configure -G "{generator}" --enable-examples')
         self.assertEqual(return_code, 0)
 
         # Copy second.cc from the tutorial examples to the scratch folder
         shutil.copy("./examples/tutorial/second.cc", "./scratch/second.cc")
 
         # Reconfigure to re-scan the scratches
-        return_code, stdout, stderr = run_ns3("configure -G \"{generator}\" --enable-examples")
+        return_code, stdout, stderr = run_ns3('configure -G "{generator}" --enable-examples')
         self.assertEqual(return_code, 0)
 
         # Try to run second and collide
@@ -2267,7 +2480,7 @@
         self.assertEqual(return_code, 1)
         self.assertIn(
             'Build target "second" is ambiguous. Try one of these: "scratch/second", "examples/tutorial/second"',
-            stdout.replace(os.sep, '/')
+            stdout.replace(os.sep, "/"),
         )
 
         # Try to run scratch/second and succeed
@@ -2285,7 +2498,7 @@
         self.assertEqual(return_code, 1)
         self.assertIn(
             'Run target "second" is ambiguous. Try one of these: "scratch/second", "examples/tutorial/second"',
-            stdout.replace(os.sep, '/')
+            stdout.replace(os.sep, "/"),
         )
 
         # Try to run scratch/second and succeed
@@ -2307,7 +2520,8 @@
 
         # First enable examples and static build
         return_code, stdout, stderr = run_ns3(
-            "configure -G \"{generator}\" --enable-examples --disable-gtk --enable-static")
+            'configure -G "{generator}" --enable-examples --disable-gtk --enable-static'
+        )
 
         if win32:
             # Configuration should fail explaining Windows
@@ -2319,7 +2533,7 @@
             self.assertEqual(return_code, 0)
 
             # Then try to build one example
-            return_code, stdout, stderr = run_ns3('build sample-simulator')
+            return_code, stdout, stderr = run_ns3("build sample-simulator")
             self.assertEqual(return_code, 0)
             self.assertIn("Built target", stdout)
 
@@ -2337,7 +2551,8 @@
 
         # First enable examples and static build
         return_code, stdout, stderr = run_ns3(
-            "configure -G \"{generator}\" --enable-examples --enable-python-bindings")
+            'configure -G "{generator}" --enable-examples --enable-python-bindings'
+        )
 
         # If configuration passes, we are half way done
         self.assertEqual(return_code, 0)
@@ -2351,7 +2566,9 @@
         self.assertEqual(return_code, 0)
 
         # Then try to run a specific test with the full relative path
-        return_code, stdout, stderr = run_program("test.py", "-p ./examples/wireless/mixed-wired-wireless", python=True)
+        return_code, stdout, stderr = run_program(
+            "test.py", "-p ./examples/wireless/mixed-wired-wireless", python=True
+        )
         self.assertEqual(return_code, 0)
 
     def test_13_FetchOptionalComponents(self):
@@ -2381,7 +2598,7 @@
             self.skipTest("Missing git")
 
         destination_contrib = os.path.join(ns3_path, "contrib/test-contrib-dependency")
-        destination_src = os.path.join(ns3_path, "src/test-src-dependant-on-contrib")
+        destination_src = os.path.join(ns3_path, "src/test-src-dependent-on-contrib")
         # Remove pre-existing directories
         if os.path.exists(destination_contrib):
             shutil.rmtree(destination_contrib)
@@ -2389,10 +2606,14 @@
             shutil.rmtree(destination_src)
 
         # Always use a fresh copy
-        shutil.copytree(os.path.join(ns3_path, "build-support/test-files/test-contrib-dependency"),
-                        destination_contrib)
-        shutil.copytree(os.path.join(ns3_path, "build-support/test-files/test-src-dependant-on-contrib"),
-                        destination_src)
+        shutil.copytree(
+            os.path.join(ns3_path, "build-support/test-files/test-contrib-dependency"),
+            destination_contrib,
+        )
+        shutil.copytree(
+            os.path.join(ns3_path, "build-support/test-files/test-src-dependent-on-contrib"),
+            destination_src,
+        )
 
         # Then configure
         return_code, stdout, stderr = run_ns3("configure --enable-examples")
@@ -2423,8 +2644,9 @@
 
         # On top of the release build configured by NS3ConfigureTestCase, also enable examples, tests and docs.
         return_code, stdout, stderr = run_ns3(
-            "configure -d release -G \"{generator}\" --enable-examples --enable-tests")
-        self.config_ok(return_code, stdout)
+            'configure -d release -G "{generator}" --enable-examples --enable-tests'
+        )
+        self.config_ok(return_code, stdout, stderr)
 
         # Check if .lock-ns3 exists, then read to get list of executables.
         self.assertTrue(os.path.exists(ns3_lock_filename))
@@ -2486,7 +2708,7 @@
         Try to run test-runner without building
         @return None
         """
-        return_code, stdout, stderr = run_ns3('build test-runner')
+        return_code, stdout, stderr = run_ns3("build test-runner")
         self.assertEqual(return_code, 0)
 
         return_code, stdout, stderr = run_ns3('run "test-runner --list" --no-build --verbose')
@@ -2523,7 +2745,9 @@
         return_code, stdout, stderr = run_ns3("build scratch-simulator")
         self.assertEqual(return_code, 0)
 
-        return_code, stdout, stderr = run_ns3("run scratch-simulator --gdb --verbose --no-build", env={"gdb_eval": "1"})
+        return_code, stdout, stderr = run_ns3(
+            "run scratch-simulator --gdb --verbose --no-build", env={"gdb_eval": "1"}
+        )
         self.assertEqual(return_code, 0)
         self.assertIn("scratch-simulator", stdout)
         if win32:
@@ -2542,7 +2766,9 @@
         return_code, stdout, stderr = run_ns3("build scratch-simulator")
         self.assertEqual(return_code, 0)
 
-        return_code, stdout, stderr = run_ns3("run scratch-simulator --valgrind --verbose --no-build")
+        return_code, stdout, stderr = run_ns3(
+            "run scratch-simulator --valgrind --verbose --no-build"
+        )
         self.assertEqual(return_code, 0)
         self.assertIn("scratch-simulator", stderr)
         self.assertIn("Memcheck", stderr)
@@ -2679,39 +2905,43 @@
         self.assertFalse(enable_sudo is True)
 
         # First we run to ensure the program was built
-        return_code, stdout, stderr = run_ns3('run scratch-simulator')
+        return_code, stdout, stderr = run_ns3("run scratch-simulator")
         self.assertEqual(return_code, 0)
         self.assertIn("Built target scratch_scratch-simulator", stdout)
         self.assertIn(cmake_build_target_command(target="scratch_scratch-simulator"), stdout)
-        scratch_simulator_path = list(filter(lambda x: x if "scratch-simulator" in x else None,
-                                             self.ns3_executables
-                                             )
-                                      )[-1]
+        scratch_simulator_path = list(
+            filter(lambda x: x if "scratch-simulator" in x else None, self.ns3_executables)
+        )[-1]
         prev_fstat = os.stat(scratch_simulator_path)  # we get the permissions before enabling sudo
 
         # Now try setting the sudo bits from the run subparser
-        return_code, stdout, stderr = run_ns3('run scratch-simulator --enable-sudo',
-                                              env={"SUDO_PASSWORD": sudo_password})
+        return_code, stdout, stderr = run_ns3(
+            "run scratch-simulator --enable-sudo", env={"SUDO_PASSWORD": sudo_password}
+        )
         self.assertEqual(return_code, 0)
         self.assertIn("Built target scratch_scratch-simulator", stdout)
         self.assertIn(cmake_build_target_command(target="scratch_scratch-simulator"), stdout)
         fstat = os.stat(scratch_simulator_path)
 
         import stat
+
         # If we are on Windows, these permissions mean absolutely nothing,
         # and on Fuse builds they might not make any sense, so we need to skip before failing
-        likely_fuse_mount = ((prev_fstat.st_mode & stat.S_ISUID) == (fstat.st_mode & stat.S_ISUID)) and \
-                            prev_fstat.st_uid == 0  # noqa
+        likely_fuse_mount = (
+            (prev_fstat.st_mode & stat.S_ISUID) == (fstat.st_mode & stat.S_ISUID)
+        ) and prev_fstat.st_uid == 0  # noqa
 
         if win32 or likely_fuse_mount:
             self.skipTest("Windows or likely a FUSE mount")
 
         # If this is a valid platform, we can continue
         self.assertEqual(fstat.st_uid, 0)  # check the file was correctly chown'ed by root
-        self.assertEqual(fstat.st_mode & stat.S_ISUID, stat.S_ISUID)  # check if normal users can run as sudo
+        self.assertEqual(
+            fstat.st_mode & stat.S_ISUID, stat.S_ISUID
+        )  # check if normal users can run as sudo
 
         # Now try setting the sudo bits as a post-build step (as set by configure subparser)
-        return_code, stdout, stderr = run_ns3('configure --enable-sudo')
+        return_code, stdout, stderr = run_ns3("configure --enable-sudo")
         self.assertEqual(return_code, 0)
 
         # Check if it was properly set in the lock file
@@ -2724,7 +2954,7 @@
                 os.remove(executable)
 
         # Try to build and then set sudo bits as a post-build step
-        return_code, stdout, stderr = run_ns3('build', env={"SUDO_PASSWORD": sudo_password})
+        return_code, stdout, stderr = run_ns3("build", env={"SUDO_PASSWORD": sudo_password})
         self.assertEqual(return_code, 0)
 
         # Check if commands are being printed for every target
@@ -2736,7 +2966,9 @@
         # Check scratch simulator yet again
         fstat = os.stat(scratch_simulator_path)
         self.assertEqual(fstat.st_uid, 0)  # check the file was correctly chown'ed by root
-        self.assertEqual(fstat.st_mode & stat.S_ISUID, stat.S_ISUID)  # check if normal users can run as sudo
+        self.assertEqual(
+            fstat.st_mode & stat.S_ISUID, stat.S_ISUID
+        )  # check if normal users can run as sudo
 
     def test_15_CommandTemplate(self):
         """!
@@ -2745,7 +2977,7 @@
         """
 
         # Command templates that are empty or do not have a '%s' should fail
-        return_code0, stdout0, stderr0 = run_ns3('run sample-simulator --command-template')
+        return_code0, stdout0, stderr0 = run_ns3("run sample-simulator --command-template")
         self.assertEqual(return_code0, 2)
         self.assertIn("argument --command-template: expected one argument", stderr0)
 
@@ -2757,8 +2989,12 @@
             self.assertIn("not all arguments converted during string formatting", stderr)
 
         # Command templates with %s should at least continue and try to run the target
-        return_code4, stdout4, _ = run_ns3('run sample-simulator --command-template "%s --PrintVersion" --verbose')
-        return_code5, stdout5, _ = run_ns3('run sample-simulator --command-template="%s --PrintVersion" --verbose')
+        return_code4, stdout4, _ = run_ns3(
+            'run sample-simulator --command-template "%s --PrintVersion" --verbose'
+        )
+        return_code5, stdout5, _ = run_ns3(
+            'run sample-simulator --command-template="%s --PrintVersion" --verbose'
+        )
         self.assertEqual((return_code4, return_code5), (0, 0))
 
         self.assertIn("sample-simulator{ext} --PrintVersion".format(ext=ext), stdout4)
@@ -2773,8 +3009,10 @@
 
         # Test if all argument passing flavors are working
         return_code0, stdout0, stderr0 = run_ns3('run "sample-simulator --help" --verbose')
-        return_code1, stdout1, stderr1 = run_ns3('run sample-simulator --command-template="%s --help" --verbose')
-        return_code2, stdout2, stderr2 = run_ns3('run sample-simulator --verbose -- --help')
+        return_code1, stdout1, stderr1 = run_ns3(
+            'run sample-simulator --command-template="%s --help" --verbose'
+        )
+        return_code2, stdout2, stderr2 = run_ns3("run sample-simulator --verbose -- --help")
 
         self.assertEqual((return_code0, return_code1, return_code2), (0, 0, 0))
         self.assertIn("sample-simulator{ext} --help".format(ext=ext), stdout0)
@@ -2783,8 +3021,10 @@
 
         # Test if the same thing happens with an additional run argument (e.g. --no-build)
         return_code0, stdout0, stderr0 = run_ns3('run "sample-simulator --help" --no-build')
-        return_code1, stdout1, stderr1 = run_ns3('run sample-simulator --command-template="%s --help" --no-build')
-        return_code2, stdout2, stderr2 = run_ns3('run sample-simulator --no-build -- --help')
+        return_code1, stdout1, stderr1 = run_ns3(
+            'run sample-simulator --command-template="%s --help" --no-build'
+        )
+        return_code2, stdout2, stderr2 = run_ns3("run sample-simulator --no-build -- --help")
         self.assertEqual((return_code0, return_code1, return_code2), (0, 0, 0))
         self.assertEqual(stdout0, stdout1)
         self.assertEqual(stdout1, stdout2)
@@ -2809,11 +3049,14 @@
         # The order of the arguments is command template,
         # arguments passed with the target itself
         # and forwarded arguments after the -- separator
-        self.assertIn("sample-simulator{ext} --PrintGroups --PrintGlobals --PrintTypeIds".format(ext=ext), stdout)
+        self.assertIn(
+            "sample-simulator{ext} --PrintGroups --PrintGlobals --PrintTypeIds".format(ext=ext),
+            stdout,
+        )
 
         # Check if it complains about the missing -- separator
         cmd0 = 'run sample-simulator --command-template="%s " --PrintTypeIds'
-        cmd1 = 'run sample-simulator --PrintTypeIds'
+        cmd1 = "run sample-simulator --PrintTypeIds"
 
         return_code0, stdout0, stderr0 = run_ns3(cmd0)
         return_code1, stdout1, stderr1 = run_ns3(cmd1)
@@ -2829,6 +3072,9 @@
         if shutil.which("lldb") is None:
             self.skipTest("Missing lldb")
 
+        return_code, stdout, stderr = run_ns3("build scratch-simulator")
+        self.assertEqual(return_code, 0)
+
         return_code, stdout, stderr = run_ns3("run scratch-simulator --lldb --verbose --no-build")
         self.assertEqual(return_code, 0)
         self.assertIn("scratch-simulator", stdout)
@@ -2854,8 +3100,10 @@
             shutil.rmtree(destination_src)
 
         # Always use a fresh copy
-        shutil.copytree(os.path.join(ns3_path, "build-support/test-files/test-package-managers"),
-                        destination_src)
+        shutil.copytree(
+            os.path.join(ns3_path, "build-support/test-files/test-package-managers"),
+            destination_src,
+        )
 
         with DockerContainerManager(self, "ubuntu:22.04") as container:
             # Install toolchain
@@ -2865,8 +3113,7 @@
             # Verify that Armadillo is not available and that we did not
             # add any new unnecessary dependency when features are not used
             try:
-                container.execute(
-                    "./ns3 configure -- -DTEST_PACKAGE_MANAGER:STRING=ON")
+                container.execute("./ns3 configure -- -DTEST_PACKAGE_MANAGER:STRING=ON")
                 self.skipTest("Armadillo is already installed")
             except DockerException as e:
                 pass
@@ -2881,14 +3128,14 @@
             # Install Armadillo with CPM
             try:
                 container.execute(
-                    "./ns3 configure -- -DNS3_CPM=ON -DTEST_PACKAGE_MANAGER:STRING=CPM")
+                    "./ns3 configure -- -DNS3_CPM=ON -DTEST_PACKAGE_MANAGER:STRING=CPM"
+                )
             except DockerException as e:
                 self.fail()
 
             # Try to build module using CPM's Armadillo
             try:
-                container.execute(
-                    "./ns3 build test-package-managers")
+                container.execute("./ns3 build test-package-managers")
             except DockerException as e:
                 self.fail()
 
@@ -2904,8 +3151,7 @@
 
             # Install VcPkg
             try:
-                container.execute(
-                    "./ns3 configure -- -DNS3_VCPKG=ON")
+                container.execute("./ns3 configure -- -DNS3_VCPKG=ON")
             except DockerException as e:
                 self.fail()
 
@@ -2917,8 +3163,7 @@
 
             # Try to build module using VcPkg's Armadillo
             try:
-                container.execute(
-                    "./ns3 build test-package-managers")
+                container.execute("./ns3 build test-package-managers")
             except DockerException as e:
                 self.fail()
 
@@ -2950,34 +3195,42 @@
         try:
             import requests
             import urllib3
+
             urllib3.disable_warnings()
         except ImportError:
             requests = None  # noqa
             self.skipTest("Requests library is not available")
 
-        regex = re.compile(r'((http|https)://[^\ \n\)\"\'\}\>\<\]\;\`\\]*)')  # noqa
+        regex = re.compile(r"((http|https)://[^\ \n\)\"\'\}\>\<\]\;\`\\]*)")  # noqa
         skipped_files = []
 
-        whitelisted_urls = {"https://gitlab.com/your-user-name/ns-3-dev",
-                            "https://www.nsnam.org/release/ns-allinone-3.31.rc1.tar.bz2",
-                            "https://www.nsnam.org/release/ns-allinone-3.X.rcX.tar.bz2",
-                            "https://www.nsnam.org/releases/ns-3-x",
-                            "https://www.nsnam.org/releases/ns-allinone-3.(x-1",
-                            "https://www.nsnam.org/releases/ns-allinone-3.x.tar.bz2",
-                            # split due to command-line formatting
-                            "https://cmake.org/cmake/help/latest/manual/cmake-",
-                            "http://www.ieeeghn.org/wiki/index.php/First-Hand:Digital_Television:_The_",
-                            # Dia placeholder xmlns address
-                            "http://www.lysator.liu.se/~alla/dia/",
-                            # Fails due to bad regex
-                            "http://www.ieeeghn.org/wiki/index.php/First-Hand:Digital_Television:_The_Digital_Terrestrial_Television_Broadcasting_(DTTB",
-                            "http://en.wikipedia.org/wiki/Namespace_(computer_science",
-                            "http://en.wikipedia.org/wiki/Bonobo_(component_model",
-                            "http://msdn.microsoft.com/en-us/library/aa365247(v=vs.85",
-                            # historical links
-                            "http://www.research.att.com/info/kpv/",
-                            "http://www.research.att.com/~gsf/",
-                            }
+        whitelisted_urls = {
+            "https://gitlab.com/your-user-name/ns-3-dev",
+            "https://www.nsnam.org/release/ns-allinone-3.31.rc1.tar.bz2",
+            "https://www.nsnam.org/release/ns-allinone-3.X.rcX.tar.bz2",
+            "https://www.nsnam.org/releases/ns-3-x",
+            "https://www.nsnam.org/releases/ns-allinone-3.(x-1",
+            "https://www.nsnam.org/releases/ns-allinone-3.x.tar.bz2",
+            "https://ns-buildmaster.ee.washington.edu:8010/",
+            # split due to command-line formatting
+            "https://cmake.org/cmake/help/latest/manual/cmake-",
+            "http://www.ieeeghn.org/wiki/index.php/First-Hand:Digital_Television:_The_",
+            # Dia placeholder xmlns address
+            "http://www.lysator.liu.se/~alla/dia/",
+            # Fails due to bad regex
+            "http://www.ieeeghn.org/wiki/index.php/First-Hand:Digital_Television:_The_Digital_Terrestrial_Television_Broadcasting_(DTTB",
+            "http://en.wikipedia.org/wiki/Namespace_(computer_science",
+            "http://en.wikipedia.org/wiki/Bonobo_(component_model",
+            "http://msdn.microsoft.com/en-us/library/aa365247(v=vs.85",
+            # historical links
+            "http://www.research.att.com/info/kpv/",
+            "http://www.research.att.com/~gsf/",
+            "http://nsnam.isi.edu/nsnam/index.php/Contributed_Code",
+            "http://scan5.coverity.com/cgi-bin/upload.py",
+            # terminal output
+            "https://github.com/Kitware/CMake/releases/download/v3.27.1/cmake-3.27.1-linux-x86_64.tar.gz-",
+            "http://mirrors.kernel.org/fedora/releases/11/Everything/i386/os/Packages/",
+        }
 
         # Scan for all URLs in all files we can parse
         files_and_urls = set()
@@ -2985,7 +3238,7 @@
         for topdir in ["bindings", "doc", "examples", "src", "utils"]:
             for root, dirs, files in os.walk(topdir):
                 # do not parse files in build directories
-                if "build" in root or "_static" in root or "source-temp" in root or 'html' in root:
+                if "build" in root or "_static" in root or "source-temp" in root or "html" in root:
                     continue
                 for file in files:
                     filepath = os.path.join(root, file)
@@ -3005,7 +3258,9 @@
                             # Get first group for each match (containing the URL)
                             # and strip final punctuation or commas in matched links
                             # commonly found in the docs
-                            urls = list(map(lambda x: x[0][:-1] if x[0][-1] in ".," else x[0], matches))
+                            urls = list(
+                                map(lambda x: x[0][:-1] if x[0][-1] in ".," else x[0], matches)
+                            )
                     except UnicodeDecodeError:
                         skipped_files.append(filepath)
                         continue
@@ -3016,13 +3271,14 @@
                         files_and_urls.add((filepath, url))
 
         # Instantiate the Django URL validator
-        from django.core.validators import URLValidator  # noqa
         from django.core.exceptions import ValidationError  # noqa
+        from django.core.validators import URLValidator  # noqa
+
         validate_url = URLValidator()
 
         # User agent string to make ACM and Elsevier let us check if links to papers are working
         headers = {
-            'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/50.0.2661.102 Safari/537.36'
+            "User-Agent": "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/50.0.2661.102 Safari/537.36"
             # noqa
         }
 
@@ -3057,17 +3313,22 @@
                     # People use the wrong code, but the reason
                     # can still be correct
                     if response.status_code in [302, 308, 500, 503]:
-                        if response.reason.lower() in ['found',
-                                                       'moved temporarily',
-                                                       'permanent redirect',
-                                                       'ok',
-                                                       'service temporarily unavailable'
-                                                       ]:
+                        if response.reason.lower() in [
+                            "found",
+                            "moved temporarily",
+                            "permanent redirect",
+                            "ok",
+                            "service temporarily unavailable",
+                        ]:
                             dead_link_msg = None
                             break
                     # In case it didn't pass in any of the previous tests,
                     # set dead_link_msg with the most recent error and try again
-                    dead_link_msg = "%s: URL %s: returned code %d" % (test_filepath, test_url, response.status_code)
+                    dead_link_msg = "%s: URL %s: returned code %d" % (
+                        test_filepath,
+                        test_url,
+                        response.status_code,
+                    )
                 except requests.exceptions.InvalidURL:
                     dead_link_msg = "%s: URL %s: invalid URL" % (test_filepath, test_url)
                 except requests.exceptions.SSLError:
@@ -3079,12 +3340,17 @@
                         error_msg = e.args[0].reason.__str__()
                     except AttributeError:
                         error_msg = e.args[0]
-                    dead_link_msg = "%s: URL %s: failed with exception: %s" % (test_filepath, test_url, error_msg)
+                    dead_link_msg = "%s: URL %s: failed with exception: %s" % (
+                        test_filepath,
+                        test_url,
+                        error_msg,
+                    )
                 tries -= 1
             return dead_link_msg
 
         # Dispatch threads to test multiple URLs concurrently
         from concurrent.futures import ThreadPoolExecutor
+
         with ThreadPoolExecutor(max_workers=100) as executor:
             dead_links = list(executor.map(test_file_url, list(files_and_urls)))
 
